
bl_info = {
	"name": "rba2ba",
	"author": "Backup",
	"version": (1, 0),
	"blender": (2, 63, 0),
	"category": "Object",
	"location": "Search -> rba2ba",
	"wiki_url": "http://google.com/",
	"tracker_url": "http://google.com/",
	"description": "Creates armature anim from rigid body anim data."}

import bpy

def main(context):
  selected=context.selected_objects
  
  scene=bpy.data.scenes['Scene']
  
  first=True
  for obj in selected:
    if first:
      bpy.ops.object.armature_add()
      bpy.data.objects['Armature'].location=(0,0,0)
      first=False
    else:
      bpy.ops.object.editmode_toggle()
      bpy.ops.armature.bone_primitive_add()
      #bpy.ops.armature.extrude_move(TRANSFORM_OT_translate={"value":(0,0,1)})
      bpy.ops.armature.extrude()#dirty hack
      bpy.ops.armature.select_hierarchy()
      bpy.ops.object.editmode_toggle()
    bone=bpy.data.objects['Armature'].pose.bones[-1]
    bone.rotation_mode='XYZ'
    frame_range=obj.animation_data.action.frame_range
    for i in range(int(frame_range[0]),int(frame_range[1])):
      bpy.context.scene.frame_set(i)
      bone.matrix=obj.matrix_basis
      bone.keyframe_insert(data_path="location")
      bone.keyframe_insert(data_path="rotation_euler")
      """try:
        obj.keyframe_delete(data_path="location")
        obj.keyframe_delete(data_path="rotation_euler")
      except:
        break"""
    obj.animation_data_clear()
    
    bpy.ops.object.posemode_toggle()
    obj.select=True
    bpy.ops.object.parent_set(type="BONE")
    obj.select=False
    bpy.ops.object.posemode_toggle()


class Rba2ba(bpy.types.Operator):
  bl_idname = "object.rba2ba"
  bl_label = "Rigid body anim to bone anim (rba2ba)"

  @classmethod
  def poll(cls, context):
    return context.active_object is not None

  def execute(self, context):
    main(context)
    return {'FINISHED'}


def register():
  bpy.utils.register_module(__name__)


def unregister():
  bpy.utils.unregister_module(__name__)


if __name__ == "__main__":
  register()